import * as React from 'react';
import { StyleProp, TextStyle } from 'react-native';
import { ALERT_TYPE } from '../config';
interface IProps {
    isDark: boolean;
    paddingTop?: number;
    type?: ALERT_TYPE;
    title?: string;
    description?: string;
    timeout: number;
    onPress?: () => void;
    onClose(): void;
    configGeneral: any;
    titleStyle?: StyleProp<TextStyle>;
    textBodyStyle?: StyleProp<TextStyle>;
}
interface IState {
    isInit: boolean;
    styles: ReturnType<typeof __styles>;
}
export declare class ToastRender extends React.Component<IProps, IState> {
    private _heightContainer;
    private _positionToast;
    private _pressStart;
    private _countdown;
    constructor(props: IProps);
    componentDidUpdate: (prevProps: Readonly<IProps>, prevState: Readonly<IState>) => Promise<void>;
    componentWillUnmount: () => void;
    private _animatedTiming;
    private _autoCloseHandler;
    private _layoutHandler;
    private _panResponder;
    private _ModelRender;
    render(): JSX.Element;
}
declare const __styles: (isDark: boolean) => {
    [x: string]: {
        position: "absolute";
        left: number;
        right: number;
        overflow?: undefined;
        flex?: undefined;
        fontWeight?: undefined;
        fontSize?: undefined;
        color?: undefined;
        alignSelf?: undefined;
        height?: undefined;
        width?: undefined;
        backgroundColor?: undefined;
        borderRadius?: undefined;
        aspectRatio?: undefined;
        marginRight?: undefined;
        tintColor?: undefined;
    } | {
        flexDirection: "row";
        paddingHorizontal: number;
        paddingTop: number;
        paddingBottom: number;
        backgroundColor: string | import("react-native").OpaqueColorValue | undefined;
        position?: undefined;
        left?: undefined;
        right?: undefined;
        overflow?: undefined;
        flex?: undefined;
        fontWeight?: undefined;
        fontSize?: undefined;
        color?: undefined;
        alignSelf?: undefined;
        height?: undefined;
        width?: undefined;
        borderRadius?: undefined;
        aspectRatio?: undefined;
        marginRight?: undefined;
        tintColor?: undefined;
    } | {
        borderRadius: number;
        marginHorizontal: number;
        marginTop?: undefined;
        flexDirection: "row";
        paddingHorizontal: number;
        paddingTop: number;
        paddingBottom: number;
        backgroundColor: string | import("react-native").OpaqueColorValue | undefined;
        position?: undefined;
        left?: undefined;
        right?: undefined;
        overflow?: undefined;
        flex?: undefined;
        fontWeight?: undefined;
        fontSize?: undefined;
        color?: undefined;
        alignSelf?: undefined;
        height?: undefined;
        width?: undefined;
        aspectRatio?: undefined;
        marginRight?: undefined;
        tintColor?: undefined;
    } | {
        marginTop: number;
        marginHorizontal: number;
        borderRadius: number;
        flexDirection: "row";
        paddingHorizontal: number;
        paddingTop: number;
        paddingBottom: number;
        backgroundColor: string | import("react-native").OpaqueColorValue | undefined;
        position?: undefined;
        left?: undefined;
        right?: undefined;
        overflow?: undefined;
        flex?: undefined;
        fontWeight?: undefined;
        fontSize?: undefined;
        color?: undefined;
        alignSelf?: undefined;
        height?: undefined;
        width?: undefined;
        aspectRatio?: undefined;
        marginRight?: undefined;
        tintColor?: undefined;
    } | {
        overflow: "hidden";
        flex: number;
        position?: undefined;
        left?: undefined;
        right?: undefined;
        fontWeight?: undefined;
        fontSize?: undefined;
        color?: undefined;
        alignSelf?: undefined;
        height?: undefined;
        width?: undefined;
        backgroundColor?: undefined;
        borderRadius?: undefined;
        aspectRatio?: undefined;
        marginRight?: undefined;
        tintColor?: undefined;
    } | {
        fontWeight: "bold";
        fontSize: number;
        color: string | import("react-native").OpaqueColorValue | undefined;
        position?: undefined;
        left?: undefined;
        right?: undefined;
        overflow?: undefined;
        flex?: undefined;
        alignSelf?: undefined;
        height?: undefined;
        width?: undefined;
        backgroundColor?: undefined;
        borderRadius?: undefined;
        aspectRatio?: undefined;
        marginRight?: undefined;
        tintColor?: undefined;
    } | {
        color: string | import("react-native").OpaqueColorValue | undefined;
        position?: undefined;
        left?: undefined;
        right?: undefined;
        overflow?: undefined;
        flex?: undefined;
        fontWeight?: undefined;
        fontSize?: undefined;
        alignSelf?: undefined;
        height?: undefined;
        width?: undefined;
        backgroundColor?: undefined;
        borderRadius?: undefined;
        aspectRatio?: undefined;
        marginRight?: undefined;
        tintColor?: undefined;
    } | {
        position: "absolute";
        alignSelf: "center";
        height: number;
        width: number;
        backgroundColor: string;
        borderRadius: number;
        left: number;
        right?: undefined;
        overflow?: undefined;
        flex?: undefined;
        fontWeight?: undefined;
        fontSize?: undefined;
        color?: undefined;
        aspectRatio?: undefined;
        marginRight?: undefined;
        tintColor?: undefined;
    } | {
        alignSelf: "center";
        width: number;
        aspectRatio: number;
        marginRight: number;
        position?: undefined;
        left?: undefined;
        right?: undefined;
        overflow?: undefined;
        flex?: undefined;
        fontWeight?: undefined;
        fontSize?: undefined;
        color?: undefined;
        height?: undefined;
        backgroundColor?: undefined;
        borderRadius?: undefined;
        tintColor?: undefined;
    } | {
        tintColor: string | import("react-native").OpaqueColorValue | undefined;
        position?: undefined;
        left?: undefined;
        right?: undefined;
        overflow?: undefined;
        flex?: undefined;
        fontWeight?: undefined;
        fontSize?: undefined;
        color?: undefined;
        alignSelf?: undefined;
        height?: undefined;
        width?: undefined;
        backgroundColor?: undefined;
        borderRadius?: undefined;
        aspectRatio?: undefined;
        marginRight?: undefined;
    };
    container: {
        position: "absolute";
        left: number;
        right: number;
    };
    cardContainer: {
        flexDirection: "row";
        paddingHorizontal: number;
        paddingTop: number;
        paddingBottom: number;
        backgroundColor: string | import("react-native").OpaqueColorValue | undefined;
    } | {
        borderRadius: number;
        marginHorizontal: number;
        marginTop?: undefined;
        flexDirection: "row";
        paddingHorizontal: number;
        paddingTop: number;
        paddingBottom: number;
        backgroundColor: string | import("react-native").OpaqueColorValue | undefined;
    } | {
        marginTop: number;
        marginHorizontal: number;
        borderRadius: number;
        flexDirection: "row";
        paddingHorizontal: number;
        paddingTop: number;
        paddingBottom: number;
        backgroundColor: string | import("react-native").OpaqueColorValue | undefined;
    };
    labelContainer: {
        overflow: "hidden";
        flex: number;
    };
    titleLabel: {
        fontWeight: "bold";
        fontSize: number;
        color: string | import("react-native").OpaqueColorValue | undefined;
    };
    descLabel: {
        color: string | import("react-native").OpaqueColorValue | undefined;
    };
    backendImage: {
        position: "absolute";
        alignSelf: "center";
        height: number;
        width: number;
        backgroundColor: string;
        borderRadius: number;
        left: number;
    };
    image: {
        alignSelf: "center";
        width: number;
        aspectRatio: number;
        marginRight: number;
    };
};
export {};
